"use strict";

// Utils.

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.syncFile = syncFile;
exports.readPassword = readPassword;
exports.exec = exec;

var _utils = require('./utils');

var utils = _interopRequireWildcard(_utils);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _prompt = require('prompt');

var _prompt2 = _interopRequireDefault(_prompt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// Sync file function.


// FS.
function syncFile(program) {
    // Read params.
    var passwordFile = program.args[0];
    var realm = program.args[1];
    var username = program.args[2];

    // Encode file data.
    var writeData = utils.encode(program);

    // Collectors.
    var found = false;
    var newLines = [];

    // Not creating file.
    if (!program.create) {
        // Check if file exists.
        if (!_fs2.default.existsSync(passwordFile)) {
            console.error('Cannot modify file ' + passwordFile + '; use \'-c\' to create it.');
            return;
        }

        // Read lines.
        var lines = _fs2.default.readFileSync(passwordFile, 'UTF-8').split("\n");

        // Loop lines.
        lines.forEach(function (line) {
            if (line.indexOf(username + ':' + realm + ':') === 0) {
                found = true;
                newLines.push(writeData);
                console.log('Changing password for user ' + username + ' in realm ' + realm + '.');
            } else {
                newLines.push(line);
            }
        });
    }

    // Adding user to existing file.
    if (!found) {
        newLines.push(writeData);
        console.log('Adding password for user ' + username + ' in realm ' + realm + '.');
    }

    // Write data.
    _fs2.default.writeFileSync(passwordFile, newLines.join("\n") + "\n", 'UTF-8');
}

// Read password.


// Prompt module.
function readPassword(program) {
    _prompt2.default.message = "";
    _prompt2.default.delimiter = "";

    var passportOption = [{ name: 'password', description: 'New password:', hidden: true }];
    var rePassportOption = [{ name: 'rePassword', description: 'Re-type new password:', hidden: true }];

    // Try to read password.
    setTimeout(function () {
        _prompt2.default.get(passportOption, function (err, result) {
            if (!err) {
                (function () {
                    var password = result.password;
                    setTimeout(function () {
                        _prompt2.default.get(rePassportOption, function (err, result) {
                            if (!err && password == result.rePassword) {
                                program.args.push(password);

                                try {
                                    syncFile(program);
                                } catch (err) {
                                    console.error(err.message);
                                }
                            } else {
                                console.error("\nPassword verification error.");
                            }
                        });
                    }, 50);
                })();
            } else {
                console.error("\nPassword verification error.");
            }
        });
    }, 50);
}

// Process command.
function exec(program) {
    if (program.args.length === 3) {
        readPassword(program);
    } else {
        program.help();
    }
}